unit OmegaZolnierz;

interface
uses
    OmegaImageList,OmegaSprite;
type
tabModel=array[0..3] of integer;
tKierunek=(kierN,kierNE,kierE,kierSE,kierS,kierSW,kierW,kierNW);
tZolnierz=class(TSprite)
  private
    Skok_X,
    Skok_Y            :single;
    fkierunek         :tKierunek;
    fdVA,
    fIDAnimacji       :real;//wspolczynniki animacji
    fIdObrazKorpus,        //indeks obrazu z listy OmegaImageList
    fIdObrazGlowa,
    fIdObrazBron,
    fIdObrazTarcza,

    fIdKlatkaKorpus,        //indesk wycinanej klatki
    fIdKlatkaGlowa,
    fIdKlatkaBron,
    fIdKlatkaTarcza
                     :integer;

    fOffSetKierunku  :byte;//przesuniecie klatek animacji wynikajace z obranego kierunku ruchu
    fOmegaImageList  :TOmegaImageList;

    fKolizja:boolean;

    function  kierunekN (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekS (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekW (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekE (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekNW(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekSW(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekNE(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
    function  kierunekSE(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja

    function  KierunekPoKolizji(const colX,colY:integer):tKierunek;

    procedure RysujNaPolnoc;
    procedure RysujNaPoludnie;
    procedure RysujNaZachod;
    procedure RysujNaWschod;

    procedure MoznaIsc(const Value:single);
    procedure Move(const MoveCount:single);override;
    procedure Draw;override;
    procedure onCollision(const Sprite:Tsprite;const colX,colY:integer);override;
  published
    property OffSetKierunku  :byte read fOffSetKierunku write fOffSetkierunku;
    property IdObrazKorpus   :integer read fIdObrazKorpus write fIdObrazKorpus;
    property IdObrazGlowa    :integer read fIdObrazGlowa  write fIdObrazGlowa;
    property IdObrazBron     :integer read fIdObrazBron   write fIdObrazBron;
    property IdObrazTarcza   :integer read fIdObrazTarcza write fIdObrazTarcza;

    property IdKlatkaKorpus   :integer read fIdKlatkaKorpus write fIdKlatkaKorpus;
    property IdKlatkaGlowa    :integer read fIdKlatkaGlowa  write fIdKlatkaGlowa;
    property IdKlatkaBron     :integer read fIdKlatkaBron   write fIdKlatkaBron;
    property IdKlatkaTarcza   :integer read fIdKlatkaTarcza write fIdKlatkaTarcza;

    property OmegaImageList   :TOmegaImageList read fOmegaImageList write fOmegaImageList;

  public
    constructor Create( const AParent: TOmegaSprite;
                        const AOmegaImageList: TOmegaImageList);virtual;
    procedure UstawObraz(Co :byte; const AIdObraz,AIdKlatka:integer);
end;
//****SZTANDAR************
tSztandar=class(TSimpleAnimSprite)
    fOmegaImageList  :TOmegaImageList;
    fKolizja         :boolean;
  public
    constructor Create( const AParent: TOmegaSprite;
                        const AOmegaImageList: TOmegaImageList;
                        const AId:integer);virtual;
    procedure Move(const MoveCount:single);override;
  published
   property  OmegaImageList :TOmegaImageList read fOmegaImageList write fOmegaImageList;
end;
//************************
var
 Zolnierz:tZolnierz;
implementation
procedure tZolnierz.UstawObraz(Co :byte; const AIdObraz,AIdKlatka:integer);
begin
 case Co of
  0:begin IdObrazKorpus:=AIdObraz;
          Image:=OmegaImageList.ImageList.Items[fIdObrazKorpus];
          fIdKlatkaKorpus:=AidKlatka;
    end;
  1:begin IdObrazGlowa :=AIdObraz;IdKlatkaGlowa :=AIdKlatka;end;
  2:begin IdObrazBron  :=AIdObraz;IdKlatkaBron  :=AIdKlatka;end;
  3:begin IdObrazTarcza:=AIdObraz;IdKlatkaTarcza:=AIdKlatka;end;
 end;
end;
procedure tZolnierz.RysujNaPolnoc;
begin
 //Tarcza,Bron,Korpus, Glowa
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
end;
procedure tZolnierz.RysujNaPoludnie;
begin
 //Korpus,Glowa,Tarcza,Bron
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
end;
procedure tZolnierz.RysujNaWschod;
begin
 //Tarcza,Korpus,Glowa,Bron
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
end;
procedure tZolnierz.RysujNaZachod;
begin
 //Bron,Korpus,Glowa,Tarcza
 if fIdObrazBron>-1 then
 OmegaImageList.ImageList.Items[fIdObrazBron].Draw(Round(x),Round(y),Round(fIdKlatkaBron+fIDAnimacji+fOffSetKierunku));
 inherited Draw;//standardowa procedura rysujaca - tu bedzie rysowac korpus
 if fIdObrazGlowa>-1 then
 OmegaImageList.ImageList.Items[fIdObrazGlowa].Draw(Round(x),Round(y-16),Round(fIdKlatkaGlowa+fIDAnimacji+fOffSetKierunku));
 if fIdObrazTarcza>-1 then
 OmegaImageList.ImageList.Items[fIdObrazTarcza].Draw(Round(x),Round(y),Round(fIdKlatkaTarcza+fIDAnimacji+fOffSetKierunku));
end;

procedure tZolnierz.Draw;
begin
 if fIdKlatkaKorpus<0 then exit;

 Case fOffSetKierunku of
 0:RysujNAPolnoc;
 3:RysujNaPoludnie;
 6:RysujNAZachod;
 9:RysujNaWschod;
 end;
end;

function  TZolnierz.kierunekN (const V:Single):tKierunek;
begin
 Skok_Y:=-25*V;
 fOffSetKierunku:=0;
 result:=kierN;
end;
function  TZolnierz.kierunekNW(const V:Single):tKierunek;
begin
 Skok_Y:=-25*V;
 Skok_X:=-25*V;
 fOffSetKierunku:=0;
 result:=kierNW;
end;
function  TZolnierz.kierunekNE(const V:Single):tKierunek;
begin
 fOffSetKierunku:=0;
 Skok_Y:=-25*V;
 Skok_X:=25*V;
 result:=kierNE;
end;

function  TZolnierz.kierunekS (const V:Single):tKierunek;
begin
 Skok_Y:=25*V;
 fOffSetKierunku:=3;
 result:=kierS;
end;
function  TZolnierz.kierunekSW(const V:Single):tKierunek;
begin
 Skok_Y:=25*V;
 Skok_X:=-25*V;
 fOffSetKierunku:=3;
 result:=kierSW;
end;
function  TZolnierz.kierunekSE(const V:Single):tKierunek;
begin

 Skok_X:=25*V;
 Skok_Y:=25*V;
 fOffSetKierunku:=3;
 result:=kierSE;
end;
function  TZolnierz.kierunekW (const V:Single):tKierunek;
begin
 Skok_X:=-25*V;
 fOffSetKierunku:=6;
 result:=kierW;
end;
function  TZolnierz.kierunekE (const V:Single):tKierunek;
begin
 Skok_X:=25*V;
 fOffSetKierunku:=9;
 result:=kierE;
end;

function TZolnierz.KierunekPoKolizji(const colX,colY:integer):tKierunek;
  var
    s,h:integer;
    kwadrat,K,W:byte;//kolumna i wierzs kwadratu zderzenia
  begin
    s:=Image.TileWidth  div 2;//wyznacz polowy z serokoci i wysokosci klatki
    h:=Image.TileHeight div 2;
    k:=colX div s;//podziel na kolumny i wiersze
    w:=colY div h;
    kwadrat:=k+w*2;//oblicz kawdrat zderzenia
    case kwadrat of
      0:result:=kierNE;//na podstwaie kawdratu zderzenia wyznacz kierunek odbicia
      1:result:=kierNW;
      2:result:=kierSE;
      3:result:=kierSW;
    end;
  end;


procedure TZolnierz.MoznaIsc(const Value:single);
begin
 case fKierunek of
      kierN  : kierunekN (Value);
      kierNE : kierunekNE(Value);
      kierE  : kierunekE (Value);
      kierSE : kierunekSE(Value);
      kierS  : kierunekS (Value);
      kierSW : kierunekSW(Value);
      kierW  : kierunekW (Value);
      kierNW : kierunekNW(Value);
 end;

 if fIDAnimacji>2 then fIDAnimacji:=0;
 fIDAnimacji:=fIDAnimacji+fdVA*Value;//fdVA to predkosc animacji
 ImageIndex:=Round(fIdKlatkaKorpus+fIDAnimacji+fOffSetKierunku);
 fdVA:=5;
 x:=x+Skok_X;
 y:=y+Skok_Y;
end;

procedure tZolnierz.Move(const MoveCount:single);
begin
 if x<0   then  begin fKierunek:=kierE;fOffsetkierunku:=9 end;
 if x>800 then  begin fKierunek:=kierW;fOffsetkierunku:=6 end;
 if y<0   then  begin fKierunek:=kierS;fOffsetkierunku:=3 end;
 if y>600 then  begin fKierunek:=kierN;fOffsetkierunku:=0 end;
 MoznaIsc(MoveCount);
 inherited Move(MoveCount);
 fKolizja     :=false;
end;

procedure TZolnierz.onCollision(const Sprite:Tsprite;const colX,colY:integer);
begin
  if (Sprite is TZolnierz)then begin
     if TZolnierz(Sprite).fKolizja then exit;
     //Przykad akcj:Zabieranie broni
     //Zabierz bron napotkanemu zolnierzowi
     TZolnierz(Sprite).IdObrazBron:=-1;
     TZolnierz(Sprite).IdObrazTarcza:=-1;
     IdObrazTarcza :=3;
     IdKlatkaBron  :=TZolnierz(Sprite).IdKlatkaBron;
     idKlatkaTarcza:=TZolnierz(Sprite).IdKlatkaTarcza;
     fKolizja:=true;
     fKierunek:=KierunekPoKolizji(colX,colY);
     fdVa:=0;//prdko animacj na czas zderzenia wyzeruj;
     case fKierunek of
      kierNW:begin x:=x-2;y:=y-2;end;
      kierNE:begin x:=x+2;y:=y-2;end;
      kierSW:begin x:=x-2;y:=y+2;end;
      kierSE:begin x:=x+2;y:=y+2;end;
     end;
  end;
  //kolizja ze sztandarem- tworzenie muszkietera
  if (Sprite is TSztandar)then begin
      if (tSztandar(Sprite).fKolizja)or(fKolizja) then exit;
      fKolizja:=true;
      tSztandar(Sprite).fKolizja:=true;
      IdObrazBron  :=2;//ustaw indeksy zasobw graficznych broni
      IdObrazTarcza:=3;//tarcz
      //muszkieter jest bez tarczy wic mu j zabierz
      IdObrazTarcza:=-1;
      //zmien klatk korpusu
      IdKlatkaKorpus:=252;//klatka munduru muszkietera - ten z ztym krzyem
      //zmien kaltk broni na szpad
      IdKlatkaBron  :=12;
  end;
end;


constructor tZolnierz.Create( const AParent: TOmegaSprite;
                              const AOmegaImageList: TOmegaImageList);
begin
   inherited Create(AParent);
   OmegaImageList:=AOmegaImageList;
   fDVA:=5;
   //usatw poczatkowe wartosci indeksw obrazw i ich klatek
   fIdObrazKorpus :=0;
   fIdObrazGlowa  :=-1;
   fIdObrazBron   :=-1;
   fIdObrazTarcza :=-1;

   fIdKlatkaKorpus:= 0;
   fIdKlatkaGlowa :=-1;
   fIdKlatkaBron  :=-1;
   fIdKlatkaTarcza:=-1;

   Image        :=OmegaImageList.ImageList.Items[fIdObrazKorpus];
   ImageIndex   :=fIdKlatkaKorpus;
   width        :=Image.TileWidth;
   height       :=Image.TileHeight;
   DoCollision  :=true;
   DoPixelCheck :=true;
   fKolizja     :=false;
end;
//******SZTANDAR*************
constructor tSztandar.Create( const AParent: TOmegaSprite;
                              const AOmegaImageList: TOmegaImageList;
                              const AId:integer);
begin
   inherited Create(AParent);
   OmegaImageList:=AOmegaImageList;
   Image        :=OmegaImageList.ImageList.Items[AId];
   ImageIndex   :=0;
   width        :=Image.TileWidth;
   height       :=Image.TileHeight;
   fKolizja     :=false;
   DoCollision  :=true;
   DoPixelCheck :=true;
   AnimLooped:=true;
   AnimSpeed :=5;
   AnimCount :=Image.NumOfRows*Image.NumOfColumns;
   AnimPos   :=Random(AnimCount-1);//ustaw losowo poczatkow klatk animacji
   DoAnimate:=true;
end;
procedure tSztandar.Move(const MoveCount:single);
begin
   inherited Move(MoveCount);
   fKolizja:=false;
end;
//***************************
end.
